var LoadingSpinner = function() {
    
    // private properties
    var canvas;
    var ctx;
    var spinner = new Image();
    var spinning = false;
    var timeOutStop = 0;
    var timer;
    
    spinner.src = "images/loading_spinner.png";
    
    // private methods
    function init(canvasId) {
        canvas = document.getElementById(canvasId);
        canvas.style.display = "none";
        ctx = canvas.getContext("2d");
        ctx.translate(25,25);
    }
    
    function redraw() {
        ctx.clearRect(-25, -25, 50, 50);
        ctx.drawImage(spinner, -25, -25);
    }
    
    function start() {
        canvas.style.display = "block";
        clearTimeout(timer);
        timeOutStop = 0;
        spinning = true;
        spin();
    }
    
    function spin() {
        if (spinning && timeOutStop < 600) { // stop spinning after (600*100)msec (1min)
            timeOutStop++;
            redraw();
            ctx.rotate(Math.PI*2/12);
            timer = setTimeout(spin, 100);
        }
    }
    
    function stop() {
        canvas.style.display = "none";
        spinning = false;
        timeOutStop = 0;
    }
    
    // public methods
    return {
        init: init,
        start: start,
        stop: stop
    }
}();